/* libutf8/src/lib/ctype.c
 *
 *  (c)2006, Laurence Withers. Released under the GNU GPL. See file
 *  COPYING for more information / terms of license.
*/

bool utf8_isascii(wchar_t ch)
{
    return !(ch & ~0x7F);
}



/* From PropList-4.1.0.txt (http://www.unicode.org/Public/UNIDATA/)

0009..000D    ; White_Space # Cc   [5] <control-0009>..<control-000D>
0020          ; White_Space # Zs       SPACE
0085          ; White_Space # Cc       <control-0085>
00A0          ; White_Space # Zs       NO-BREAK SPACE
1680          ; White_Space # Zs       OGHAM SPACE MARK
180E          ; White_Space # Zs       MONGOLIAN VOWEL SEPARATOR
2000..200A    ; White_Space # Zs  [11] EN QUAD..HAIR SPACE
2028          ; White_Space # Zl       LINE SEPARATOR
2029          ; White_Space # Zp       PARAGRAPH SEPARATOR
202F          ; White_Space # Zs       NARROW NO-BREAK SPACE
205F          ; White_Space # Zs       MEDIUM MATHEMATICAL SPACE
3000          ; White_Space # Zs       IDEOGRAPHIC SPACE
*/

bool utf8_isspace(wchar_t ch)
{
    return((ch >= 0x0009 && ch <= 0x000D)
            || ch == 0x0020
            || ch == 0x0085
            || ch == 0x00A0
            || ch == 0x1680
            || ch == 0x180E
            || (ch >= 0x2000 && ch <= 0x200A)
            || ch == 0x2028
            || ch == 0x2029
            || ch == 0x202F
            || ch == 0x205F
            || ch == 0x3000);
}



bool utf8_isvalid(wchar_t ch)
{
    return !(ch & (~((wchar_t)0x7FFFFFFF))) && (ch < 0xD800 || ch > 0xDFFF) && (ch != 0xFFFE) && (ch != 0xFFFF);
}

/* options for text editors
kate: replace-trailing-space-save true; space-indent true; tab-width 4;
*/
